<?php
/**
 * Created by PhpStorm.
 * User: carinaoliveira
 * Date: 02/12/2014
 * Time: 11:45
 */

namespace Fiscal\Logic\ErrosAvisosNF;

use Fiscal\Entities\Erroavisonf;
use Indeterminado\Entities\Erroavisonffil;

class ErrosAvisosNF {

    //Busca se existe algum registro na tabela 'ERROAVISONF'
    public static function buscaLista ($nrorg) {

        $sucesso = false;

        try {
            $errosAvisosNF = Erroavisonf::findByNrorg($nrorg);

            if(count($errosAvisosNF) > 0) {
                $sucesso = true;
            }

        }
        catch (\Exception $e) {
            throw $e;
            $db->rollback();
        }

        return $sucesso;

    }

    //Insere uma lista na tabela 'ERROAVISONF'
    public static function insereListaErrosAvisosNF ($nrorg, $operador, $data, $listaErrosAvisosNF){
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();

        try {

            foreach($listaErrosAvisosNF as $cderroaviso) {
                $erroAvisoNF = new Erroavisonf();

                $erroAvisoNF->setCderroaviso($cderroaviso);
                $erroAvisoNF->setIderroaviso('C');

                $erroAvisoNF->setNrorg($nrorg);
                $erroAvisoNF->setIdativo('S');
                $erroAvisoNF->setDtultatu($data);
                $erroAvisoNF->setCdoperultatu($operador);
                $erroAvisoNF->setNrorgultatu($nrorg);
                $erroAvisoNF->setDtinclusao($data);
                $erroAvisoNF->setCdoperinclusao($operador);
                $erroAvisoNF->setNrorginclusao($nrorg);

                $erroAvisoNF->persist();
            }

            $connection->flush();
            $db->commit();

        } catch (\Exception $e) {
            $db->rollback();
        }
    }

    ////
    ////
    //Verifica se a filial informada no filtro existe na tabela "ERROAVISONFFIL"
    public static function buscaFilialErrosAvisosNF($cdfilial, $nrorg, $operador, $data, $listaErrosAvisosNF) {

        try {
            $filialErrosAvisosNF = Erroavisonffil::findByNrorgAndCdfilial($nrorg, $cdfilial);

            //Se já existir a filial na tabela, retira do array os codigos de erros e avisos da nf que ja estao
            //cadastrados e chama a funcao inserir passando o novo array para inserir os outros codigos
            if(count($filialErrosAvisosNF) > 0) {
                if(count($filialErrosAvisosNF) != 23) {
                    foreach($filialErrosAvisosNF as $cderroavisofilial) {

                        if (($key = array_search($cderroavisofilial->getCderroavisofil(), $listaErrosAvisosNF)) !== false) {
                            unset($listaErrosAvisosNF[$key]);
                        }

                    }

                    self::insereListaErrosAvisosNFFilial ($cdfilial, $nrorg, $operador, $data, $listaErrosAvisosNF);
                }

            }
            //Se a filial nao existir, chama a funcao inserir passando o array para inserir todos os codigos de erros e
            //avisos da nf
            else {
                self::insereListaErrosAvisosNFFilial ($cdfilial, $nrorg, $operador, $data, $listaErrosAvisosNF);
            }

        }
        catch (\Exception $e) {
            throw $e;
            $db->rollback();
        }
    }

    //
    //Insere na tabela 'ERROAVISONFFIL' todos os codigos que ainda nao existem relacionados com a filial informada no
    //filtro
    public static function insereListaErrosAvisosNFFilial ($cdfilial, $nrorg, $operador, $data, $listaErrosAvisosNF){
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();

        try {

            foreach($listaErrosAvisosNF as $cderroaviso) {
                $erroAvisoNFFilial = new Erroavisonffil();

                $erroAvisoNFFilial->setCdfilial($cdfilial);
                $erroAvisoNFFilial->setCderroavisofil($cderroaviso);
                $erroAvisoNFFilial->setIderroavisofil('C');

                $erroAvisoNFFilial->setNrorg($nrorg);
                $erroAvisoNFFilial->setIdativo('S');
                $erroAvisoNFFilial->setDtultatu($data);
                $erroAvisoNFFilial->setCdoperultatu($operador);
                $erroAvisoNFFilial->setNrorgultatu($nrorg);
                $erroAvisoNFFilial->setDtinclusao($data);
                $erroAvisoNFFilial->setCdoperinclusao($operador);
                $erroAvisoNFFilial->setNrorginclusao($nrorg);

                $erroAvisoNFFilial->persist();
            }

            $connection->flush();
            $db->commit();
            tk_reload_data_with_filter();

        } catch (\Exception $e) {
            $db->rollback();
        }
    }


}