/* Sistemas Integrados TECNISA

Nome: InsereSubProd.SQL

Descrio:
Insere subprodutos automaticamente para itens de trabalho.

Criao:
05/15/04 - Tlio
*/

CREATE OR REPLACE
PROCEDURE ISNSERE_SUBPROD
  (P_CDITEMINI  IN ITEMTRABPROD.CDITEMTRAB%TYPE,
   P_CDITEMFIN  IN ITEMTRABPROD.CDITEMTRAB%TYPE,
   P_STSUBPROD  IN PRODUTO.CDPRODUTO%TYPE,
   P_CDFILIAL   IN PARFILIALGEP.CDFILIAL%TYPE,
   P_TSTSUBPROD IN VARCHAR) IS

BEGIN

   FOR C_SUBPROD IN (SELECT
                        PR.CDPRODUTO
                     FROM
                        PRODUTO PR, GRUPPROD GP, SUBGRUPPROD SG, PRSUBGRPROD NS, PARFILIALGEP PG
                     WHERE
                        (PR.CDNVPRODUTO = '3'           ) AND
                        (GP.CDGRUPPROD  = SG.CDGRUPPROD ) AND
                        (SG.CDGRUPPROD  = NS.CDGRUPPROD ) AND
                        (SG.CDSUBGRPROD = NS.CDSUBGRPROD) AND
                        (NS.CDGRUPPROD  = PG.CDGRUPPROD ) AND
                        (NS.CDPRODUTO   = PR.CDPRODUTO  ) AND
                        (NS.CDGRUPPROD  = PG.CDGRUPPROD ) AND
                        ((INSTR(P_STSUBPROD, '_'||PR.CDPRODUTO||'_') <> 0) OR P_STSUBPROD = 'T') AND
                        (PG.CDFILIAL    = P_CDFILIAL   ) AND
                        (NS.CDFILISUBGR IN ('P',P_CDFILIAL))) LOOP
      FOR C_ITEMTRAB IN (SELECT CDITEMTRAB
                         FROM   ITEMTRAB
                         WHERE CDARVITTRAB BETWEEN P_CDITEMINI AND P_CDITEMFIN) LOOP
         INSERT INTO ITEMTRABPROD(CDPRODCOMP, CDITEMTRAB)
         VALUES(C_SUBPROD.CDPRODUTO, C_ITEMTRAB.CDITEMTRAB);
      END LOOP;
   END LOOP;
END;
/
